/*******************************************************************************
 *  Copyright 2017-2018 Centre for Development of Advanced Computing(C-DAC), Pune
 *  
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *  
 *   http://www.apache.org/licenses/LICENSE-2.0
 *  
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *******************************************************************************/
package cdac.medinfo.sdk.dcm30_04.baselibs;

import cdac.medinfo.sdk.dcm30_04.commoninterface.IDataElement;
import cdac.medinfo.sdk.dcm30_04.commoninterface.IDicomValue;
import cdac.medinfo.sdk.dcm30_04.commoninterface.IDictionaryReader;
import cdac.medinfo.sdk.dcm30_04.commoninterface.ITransferSyntax;
import cdac.medinfo.sdk.dcm30_04.utils.DicomConstants;

/**
* This item class contains the methods to set, get and validate the attribute present in Overridden Parameters Sequence .
 */

public class OverriddenParametersSequenceItem extends SelectorAttributeMacroDependentItem  
{
	

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;

	/**
	 * This constructor creates the item and internal code sequence macro with default TransferSyntax 
	 */
	OverriddenParametersSequenceItem()
	{
		super();
	}
	/**
	 * This constructor creates the item and internal code sequence macro with default TransferSyntax 
	 * and default DictionaryReader
	 * @param objITransferSyntax specifies the DICOM Standard defined TransfeSyntax
	 */
	OverriddenParametersSequenceItem(ITransferSyntax objITransferSyntax)
	{
		super(objITransferSyntax);
	}

	/**
	 * This constructor creates OverrideSequenceItem with specified TransferSyntax and
	 * specified DictionaryReader
	 * @param objTransferSyntax specifies the DICOM Standard defined TransfeSyntax
	 * @param objDictionaryReader specifies the DICOM Dictionary reader to be used 
	 */
	OverriddenParametersSequenceItem(ITransferSyntax objTransferSyntax, IDictionaryReader objDictionaryReader)
	{
		super(objTransferSyntax,objDictionaryReader);
	}
	
	/**
	 * Sets the Operator's Name.
	 * @param strOperatorsName user-defined comments
	 */
	public void setOperatorsName(String strOperatorsName)
	{
		/*Accept the OperatorsName in String format of type PN.
		 * Read the Transfer Syntax and check if ImplicitDE or ExplicitDE to create
		 * 
		 * Set the iGroupNumber and iElementNumber to ImplicitDE object 
		 * Set the iVRType
		 * Set length from the element
		 * Add this element to the Data Set
		 */
		IDataElement objIDataElement = null;
		if(objITransferSyntax.getVRTransferSyntax() == DicomConstants.DCM_VR_IMPLICIT)
			objIDataElement = new ImplicitDE(0x0008, 0x1070, strOperatorsName,getDictionaryReader());
		else
			objIDataElement = new ExplicitDE(0x0008, 0x1070,DicomConstants.DCM_DT_ST, strOperatorsName);

		addDataElement(objIDataElement);
	}

	/**
	 * Retrieves OperatorsName.
	 * @return String value of Operator's Name.
	 */
	public String getHumanPerformersName()
	{
		Object objValue = getValue(0x0008, 0x1070);
		if(objValue != null)
			return objValue.toString();
		return null;
	}
	/**
	 * Retrieves pre-initialized object of Operator Identification Sequence.If the module contains the sequence object
	 * it returns the same otherwise it creates the sequence adds to the module with proper initialization
	 * and then returns the object of sequence.
	 * @return OperatorIdentificationSequence - instance of OperatorIdentificationSequence. 
	 */
	public OperatorIdentificationSequence getOperatorIdentificationSequence()
	{
		OperatorIdentificationSequence objOperatorIdentificationSequence = null;
		IDataElement objIDataElement =  getDataForTag(0x0008, 0x1072);
		if(objIDataElement != null)
		{
			IDicomValue objIDicomValue = objIDataElement.getDicomValue();
			if(objIDicomValue != null)
				objOperatorIdentificationSequence = (OperatorIdentificationSequence)objIDicomValue;
		}
		else
		{
			DicomV3Factory objDicomV3Factory = DicomV3Factory.createInstance();
			int iVRTransferSyntax = objITransferSyntax.getVRTransferSyntax();
			objIDataElement = null;
			objOperatorIdentificationSequence = (OperatorIdentificationSequence)objDicomV3Factory.createSequence(0x0008, 0x1072, objITransferSyntax, objIDictionaryReader);

			if(iVRTransferSyntax == DicomConstants.DCM_VR_IMPLICIT)
				objIDataElement = new ImplicitDE(0x0008, 0x1072, objOperatorIdentificationSequence.getValue(),objIDictionaryReader);
			else
				objIDataElement = new ExplicitDE(0x0008, 0x1072, DicomConstants.DCM_DT_SQ, objOperatorIdentificationSequence.getValue());
			objIDataElement.setTransferSyntax(objITransferSyntax);
			if(objIDataElement != null)
				addDataElement(objIDataElement);
		}
		return objOperatorIdentificationSequence;
	}
	/**
	 * Sets the OverrideReason.
	 * @param strOverrideReason user-defined comments
	 */
	public void setOverrideReason(String strOverrideReason)
	{
		/*Accept the OverrideReason in String format of type ST.
		 * Read the Transfer Syntax and check if ImplicitDE or ExplicitDE to create
		 * 
		 * Set the iGroupNumber and iElementNumber to ImplicitDE object 
		 * Set the iVRType
		 * Set length from the element
		 * Add this element to the Data Set
		 */
		IDataElement objIDataElement = null;
		if(objITransferSyntax.getVRTransferSyntax() == DicomConstants.DCM_VR_IMPLICIT)
			objIDataElement = new ImplicitDE(0x3008, 0x0066, strOverrideReason,getDictionaryReader());
		else
			objIDataElement = new ExplicitDE(0x3008, 0x0066,DicomConstants.DCM_DT_ST, strOverrideReason);

		addDataElement(objIDataElement);
	}

	/**
	 * Retrieves the OverrideReason.
	 * @return String value of OverrideReason.
	 */
	public String getOverrideReason()
	{
		Object objValue = getValue(0x3008, 0x0066);
		if(objValue != null)
			return objValue.toString();
		return null;
	}

}
